// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hri_msgs:msg/FacialLandmarks.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__FACIAL_LANDMARKS__STRUCT_HPP_
#define HRI_MSGS__MSG__DETAIL__FACIAL_LANDMARKS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'landmarks'
#include "hri_msgs/msg/detail/normalized_point_of_interest2_d__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hri_msgs__msg__FacialLandmarks __attribute__((deprecated))
#else
# define DEPRECATED__hri_msgs__msg__FacialLandmarks __declspec(deprecated)
#endif

namespace hri_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct FacialLandmarks_
{
  using Type = FacialLandmarks_<ContainerAllocator>;

  explicit FacialLandmarks_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->landmarks.fill(hri_msgs::msg::NormalizedPointOfInterest2D_<ContainerAllocator>{_init});
      this->height = 0ul;
      this->width = 0ul;
    }
  }

  explicit FacialLandmarks_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    landmarks(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->landmarks.fill(hri_msgs::msg::NormalizedPointOfInterest2D_<ContainerAllocator>{_alloc, _init});
      this->height = 0ul;
      this->width = 0ul;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _landmarks_type =
    std::array<hri_msgs::msg::NormalizedPointOfInterest2D_<ContainerAllocator>, 70>;
  _landmarks_type landmarks;
  using _height_type =
    uint32_t;
  _height_type height;
  using _width_type =
    uint32_t;
  _width_type width;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__landmarks(
    const std::array<hri_msgs::msg::NormalizedPointOfInterest2D_<ContainerAllocator>, 70> & _arg)
  {
    this->landmarks = _arg;
    return *this;
  }
  Type & set__height(
    const uint32_t & _arg)
  {
    this->height = _arg;
    return *this;
  }
  Type & set__width(
    const uint32_t & _arg)
  {
    this->width = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t RIGHT_EAR =
    0u;
  static constexpr uint8_t RIGHT_PROFILE_1 =
    1u;
  static constexpr uint8_t RIGHT_PROFILE_2 =
    2u;
  static constexpr uint8_t RIGHT_PROFILE_3 =
    3u;
  static constexpr uint8_t RIGHT_PROFILE_4 =
    4u;
  static constexpr uint8_t RIGHT_PROFILE_5 =
    5u;
  static constexpr uint8_t RIGHT_PROFILE_6 =
    6u;
  static constexpr uint8_t RIGHT_PROFILE_7 =
    7u;
  static constexpr uint8_t MENTON =
    8u;
  static constexpr uint8_t LEFT_EAR =
    16u;
  static constexpr uint8_t LEFT_PROFILE_1 =
    15u;
  static constexpr uint8_t LEFT_PROFILE_2 =
    14u;
  static constexpr uint8_t LEFT_PROFILE_3 =
    13u;
  static constexpr uint8_t LEFT_PROFILE_4 =
    12u;
  static constexpr uint8_t LEFT_PROFILE_5 =
    11u;
  static constexpr uint8_t LEFT_PROFILE_6 =
    10u;
  static constexpr uint8_t LEFT_PROFILE_7 =
    9u;
  static constexpr uint8_t RIGHT_EYEBROW_OUTSIDE =
    17u;
  static constexpr uint8_t RIGHT_EYEBROW_1 =
    18u;
  static constexpr uint8_t RIGHT_EYEBROW_2 =
    19u;
  static constexpr uint8_t RIGHT_EYEBROW_3 =
    20u;
  static constexpr uint8_t RIGHT_EYEBROW_INSIDE =
    21u;
  static constexpr uint8_t RIGHT_EYE_OUTSIDE =
    36u;
  static constexpr uint8_t RIGHT_EYE_TOP_1 =
    37u;
  static constexpr uint8_t RIGHT_EYE_TOP_2 =
    38u;
  static constexpr uint8_t RIGHT_EYE_INSIDE =
    39u;
  static constexpr uint8_t RIGHT_EYE_BOTTOM_1 =
    41u;
  static constexpr uint8_t RIGHT_EYE_BOTTOM_2 =
    40u;
  static constexpr uint8_t RIGHT_PUPIL =
    68u;
  static constexpr uint8_t LEFT_EYEBROW_OUTSIDE =
    26u;
  static constexpr uint8_t LEFT_EYEBROW_1 =
    25u;
  static constexpr uint8_t LEFT_EYEBROW_2 =
    24u;
  static constexpr uint8_t LEFT_EYEBROW_3 =
    23u;
  static constexpr uint8_t LEFT_EYEBROW_INSIDE =
    22u;
  static constexpr uint8_t LEFT_EYE_OUTSIDE =
    45u;
  static constexpr uint8_t LEFT_EYE_TOP_1 =
    44u;
  static constexpr uint8_t LEFT_EYE_TOP_2 =
    43u;
  static constexpr uint8_t LEFT_EYE_INSIDE =
    42u;
  static constexpr uint8_t LEFT_EYE_BOTTOM_1 =
    46u;
  static constexpr uint8_t LEFT_EYE_BOTTOM_2 =
    47u;
  static constexpr uint8_t LEFT_PUPIL =
    69u;
  static constexpr uint8_t SELLION =
    27u;
  static constexpr uint8_t NOSE_1 =
    28u;
  static constexpr uint8_t NOSE_2 =
    29u;
  static constexpr uint8_t NOSE =
    30u;
  static constexpr uint8_t NOSTRIL_1 =
    31u;
  static constexpr uint8_t NOSTRIL_2 =
    32u;
  static constexpr uint8_t NOSTRIL_3 =
    33u;
  static constexpr uint8_t NOSTRIL_4 =
    34u;
  static constexpr uint8_t NOSTRIL_5 =
    35u;
  static constexpr uint8_t MOUTH_OUTER_RIGHT =
    48u;
  static constexpr uint8_t MOUTH_OUTER_TOP_1 =
    49u;
  static constexpr uint8_t MOUTH_OUTER_TOP_2 =
    50u;
  static constexpr uint8_t MOUTH_OUTER_TOP_3 =
    51u;
  static constexpr uint8_t MOUTH_OUTER_TOP_4 =
    52u;
  static constexpr uint8_t MOUTH_OUTER_TOP_5 =
    53u;
  static constexpr uint8_t MOUTH_OUTER_LEFT =
    54u;
  static constexpr uint8_t MOUTH_OUTER_BOTTOM_1 =
    59u;
  static constexpr uint8_t MOUTH_OUTER_BOTTOM_2 =
    58u;
  static constexpr uint8_t MOUTH_OUTER_BOTTOM_3 =
    57u;
  static constexpr uint8_t MOUTH_OUTER_BOTTOM_4 =
    56u;
  static constexpr uint8_t MOUTH_OUTER_BOTTOM_5 =
    55u;
  static constexpr uint8_t MOUTH_INNER_RIGHT =
    60u;
  static constexpr uint8_t MOUTH_INNER_TOP_1 =
    61u;
  static constexpr uint8_t MOUTH_INNER_TOP_2 =
    62u;
  static constexpr uint8_t MOUTH_INNER_TOP_3 =
    63u;
  static constexpr uint8_t MOUTH_INNER_LEFT =
    64u;
  static constexpr uint8_t MOUTH_INNER_BOTTOM_1 =
    67u;
  static constexpr uint8_t MOUTH_INNER_BOTTOM_2 =
    66u;
  static constexpr uint8_t MOUTH_INNER_BOTTOM_3 =
    65u;

  // pointer types
  using RawPtr =
    hri_msgs::msg::FacialLandmarks_<ContainerAllocator> *;
  using ConstRawPtr =
    const hri_msgs::msg::FacialLandmarks_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hri_msgs::msg::FacialLandmarks_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hri_msgs::msg::FacialLandmarks_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::FacialLandmarks_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::FacialLandmarks_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::FacialLandmarks_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::FacialLandmarks_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hri_msgs::msg::FacialLandmarks_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hri_msgs::msg::FacialLandmarks_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hri_msgs__msg__FacialLandmarks
    std::shared_ptr<hri_msgs::msg::FacialLandmarks_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hri_msgs__msg__FacialLandmarks
    std::shared_ptr<hri_msgs::msg::FacialLandmarks_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FacialLandmarks_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->landmarks != other.landmarks) {
      return false;
    }
    if (this->height != other.height) {
      return false;
    }
    if (this->width != other.width) {
      return false;
    }
    return true;
  }
  bool operator!=(const FacialLandmarks_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FacialLandmarks_

// alias to use template instance with default allocator
using FacialLandmarks =
  hri_msgs::msg::FacialLandmarks_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::RIGHT_EAR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::RIGHT_PROFILE_1;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::RIGHT_PROFILE_2;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::RIGHT_PROFILE_3;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::RIGHT_PROFILE_4;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::RIGHT_PROFILE_5;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::RIGHT_PROFILE_6;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::RIGHT_PROFILE_7;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::MENTON;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::LEFT_EAR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::LEFT_PROFILE_1;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::LEFT_PROFILE_2;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::LEFT_PROFILE_3;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::LEFT_PROFILE_4;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::LEFT_PROFILE_5;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::LEFT_PROFILE_6;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::LEFT_PROFILE_7;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::RIGHT_EYEBROW_OUTSIDE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::RIGHT_EYEBROW_1;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::RIGHT_EYEBROW_2;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::RIGHT_EYEBROW_3;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::RIGHT_EYEBROW_INSIDE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::RIGHT_EYE_OUTSIDE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::RIGHT_EYE_TOP_1;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::RIGHT_EYE_TOP_2;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::RIGHT_EYE_INSIDE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::RIGHT_EYE_BOTTOM_1;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::RIGHT_EYE_BOTTOM_2;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::RIGHT_PUPIL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::LEFT_EYEBROW_OUTSIDE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::LEFT_EYEBROW_1;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::LEFT_EYEBROW_2;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::LEFT_EYEBROW_3;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::LEFT_EYEBROW_INSIDE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::LEFT_EYE_OUTSIDE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::LEFT_EYE_TOP_1;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::LEFT_EYE_TOP_2;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::LEFT_EYE_INSIDE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::LEFT_EYE_BOTTOM_1;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::LEFT_EYE_BOTTOM_2;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::LEFT_PUPIL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::SELLION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::NOSE_1;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::NOSE_2;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::NOSE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::NOSTRIL_1;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::NOSTRIL_2;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::NOSTRIL_3;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::NOSTRIL_4;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::NOSTRIL_5;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::MOUTH_OUTER_RIGHT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::MOUTH_OUTER_TOP_1;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::MOUTH_OUTER_TOP_2;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::MOUTH_OUTER_TOP_3;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::MOUTH_OUTER_TOP_4;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::MOUTH_OUTER_TOP_5;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::MOUTH_OUTER_LEFT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::MOUTH_OUTER_BOTTOM_1;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::MOUTH_OUTER_BOTTOM_2;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::MOUTH_OUTER_BOTTOM_3;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::MOUTH_OUTER_BOTTOM_4;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::MOUTH_OUTER_BOTTOM_5;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::MOUTH_INNER_RIGHT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::MOUTH_INNER_TOP_1;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::MOUTH_INNER_TOP_2;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::MOUTH_INNER_TOP_3;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::MOUTH_INNER_LEFT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::MOUTH_INNER_BOTTOM_1;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::MOUTH_INNER_BOTTOM_2;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialLandmarks_<ContainerAllocator>::MOUTH_INNER_BOTTOM_3;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace hri_msgs

#endif  // HRI_MSGS__MSG__DETAIL__FACIAL_LANDMARKS__STRUCT_HPP_
