// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hri_msgs:msg/LiveSpeech.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__LIVE_SPEECH__STRUCT_HPP_
#define HRI_MSGS__MSG__DETAIL__LIVE_SPEECH__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hri_msgs__msg__LiveSpeech __attribute__((deprecated))
#else
# define DEPRECATED__hri_msgs__msg__LiveSpeech __declspec(deprecated)
#endif

namespace hri_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct LiveSpeech_
{
  using Type = LiveSpeech_<ContainerAllocator>;

  explicit LiveSpeech_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->incremental = "";
      this->final = "";
      this->confidence = 0.0;
      this->locale = "";
      this->language = "";
    }
  }

  explicit LiveSpeech_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    incremental(_alloc),
    final(_alloc),
    locale(_alloc),
    language(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->incremental = "";
      this->final = "";
      this->confidence = 0.0;
      this->locale = "";
      this->language = "";
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _incremental_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _incremental_type incremental;
  using _final_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _final_type final;
  using _confidence_type =
    double;
  _confidence_type confidence;
  using _locale_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _locale_type locale;
  using _language_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _language_type language;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__incremental(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->incremental = _arg;
    return *this;
  }
  Type & set__final(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->final = _arg;
    return *this;
  }
  Type & set__confidence(
    const double & _arg)
  {
    this->confidence = _arg;
    return *this;
  }
  Type & set__locale(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->locale = _arg;
    return *this;
  }
  Type & set__language(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->language = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hri_msgs::msg::LiveSpeech_<ContainerAllocator> *;
  using ConstRawPtr =
    const hri_msgs::msg::LiveSpeech_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hri_msgs::msg::LiveSpeech_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hri_msgs::msg::LiveSpeech_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::LiveSpeech_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::LiveSpeech_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::LiveSpeech_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::LiveSpeech_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hri_msgs::msg::LiveSpeech_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hri_msgs::msg::LiveSpeech_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hri_msgs__msg__LiveSpeech
    std::shared_ptr<hri_msgs::msg::LiveSpeech_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hri_msgs__msg__LiveSpeech
    std::shared_ptr<hri_msgs::msg::LiveSpeech_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LiveSpeech_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->incremental != other.incremental) {
      return false;
    }
    if (this->final != other.final) {
      return false;
    }
    if (this->confidence != other.confidence) {
      return false;
    }
    if (this->locale != other.locale) {
      return false;
    }
    if (this->language != other.language) {
      return false;
    }
    return true;
  }
  bool operator!=(const LiveSpeech_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LiveSpeech_

// alias to use template instance with default allocator
using LiveSpeech =
  hri_msgs::msg::LiveSpeech_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace hri_msgs

#endif  // HRI_MSGS__MSG__DETAIL__LIVE_SPEECH__STRUCT_HPP_
