// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hri_msgs:msg/Skeleton2D.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__SKELETON2_D__STRUCT_HPP_
#define HRI_MSGS__MSG__DETAIL__SKELETON2_D__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'skeleton'
#include "hri_msgs/msg/detail/normalized_point_of_interest2_d__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hri_msgs__msg__Skeleton2D __attribute__((deprecated))
#else
# define DEPRECATED__hri_msgs__msg__Skeleton2D __declspec(deprecated)
#endif

namespace hri_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Skeleton2D_
{
  using Type = Skeleton2D_<ContainerAllocator>;

  explicit Skeleton2D_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->skeleton.fill(hri_msgs::msg::NormalizedPointOfInterest2D_<ContainerAllocator>{_init});
    }
  }

  explicit Skeleton2D_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    skeleton(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->skeleton.fill(hri_msgs::msg::NormalizedPointOfInterest2D_<ContainerAllocator>{_alloc, _init});
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _skeleton_type =
    std::array<hri_msgs::msg::NormalizedPointOfInterest2D_<ContainerAllocator>, 18>;
  _skeleton_type skeleton;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__skeleton(
    const std::array<hri_msgs::msg::NormalizedPointOfInterest2D_<ContainerAllocator>, 18> & _arg)
  {
    this->skeleton = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t NOSE =
    0u;
  static constexpr uint8_t NECK =
    1u;
  static constexpr uint8_t RIGHT_SHOULDER =
    2u;
  static constexpr uint8_t RIGHT_ELBOW =
    3u;
  static constexpr uint8_t RIGHT_WRIST =
    4u;
  static constexpr uint8_t LEFT_SHOULDER =
    5u;
  static constexpr uint8_t LEFT_ELBOW =
    6u;
  static constexpr uint8_t LEFT_WRIST =
    7u;
  static constexpr uint8_t RIGHT_HIP =
    8u;
  static constexpr uint8_t RIGHT_KNEE =
    9u;
  static constexpr uint8_t RIGHT_ANKLE =
    10u;
  static constexpr uint8_t LEFT_HIP =
    11u;
  static constexpr uint8_t LEFT_KNEE =
    12u;
  static constexpr uint8_t LEFT_ANKLE =
    13u;
  static constexpr uint8_t LEFT_EYE =
    14u;
  static constexpr uint8_t RIGHT_EYE =
    15u;
  static constexpr uint8_t LEFT_EAR =
    16u;
  static constexpr uint8_t RIGHT_EAR =
    17u;

  // pointer types
  using RawPtr =
    hri_msgs::msg::Skeleton2D_<ContainerAllocator> *;
  using ConstRawPtr =
    const hri_msgs::msg::Skeleton2D_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hri_msgs::msg::Skeleton2D_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hri_msgs::msg::Skeleton2D_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::Skeleton2D_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::Skeleton2D_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::Skeleton2D_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::Skeleton2D_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hri_msgs::msg::Skeleton2D_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hri_msgs::msg::Skeleton2D_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hri_msgs__msg__Skeleton2D
    std::shared_ptr<hri_msgs::msg::Skeleton2D_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hri_msgs__msg__Skeleton2D
    std::shared_ptr<hri_msgs::msg::Skeleton2D_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Skeleton2D_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->skeleton != other.skeleton) {
      return false;
    }
    return true;
  }
  bool operator!=(const Skeleton2D_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Skeleton2D_

// alias to use template instance with default allocator
using Skeleton2D =
  hri_msgs::msg::Skeleton2D_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Skeleton2D_<ContainerAllocator>::NOSE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Skeleton2D_<ContainerAllocator>::NECK;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Skeleton2D_<ContainerAllocator>::RIGHT_SHOULDER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Skeleton2D_<ContainerAllocator>::RIGHT_ELBOW;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Skeleton2D_<ContainerAllocator>::RIGHT_WRIST;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Skeleton2D_<ContainerAllocator>::LEFT_SHOULDER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Skeleton2D_<ContainerAllocator>::LEFT_ELBOW;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Skeleton2D_<ContainerAllocator>::LEFT_WRIST;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Skeleton2D_<ContainerAllocator>::RIGHT_HIP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Skeleton2D_<ContainerAllocator>::RIGHT_KNEE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Skeleton2D_<ContainerAllocator>::RIGHT_ANKLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Skeleton2D_<ContainerAllocator>::LEFT_HIP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Skeleton2D_<ContainerAllocator>::LEFT_KNEE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Skeleton2D_<ContainerAllocator>::LEFT_ANKLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Skeleton2D_<ContainerAllocator>::LEFT_EYE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Skeleton2D_<ContainerAllocator>::RIGHT_EYE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Skeleton2D_<ContainerAllocator>::LEFT_EAR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Skeleton2D_<ContainerAllocator>::RIGHT_EAR;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace hri_msgs

#endif  // HRI_MSGS__MSG__DETAIL__SKELETON2_D__STRUCT_HPP_
