// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hri_msgs:msg/SoftBiometrics.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__SOFT_BIOMETRICS__STRUCT_HPP_
#define HRI_MSGS__MSG__DETAIL__SOFT_BIOMETRICS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hri_msgs__msg__SoftBiometrics __attribute__((deprecated))
#else
# define DEPRECATED__hri_msgs__msg__SoftBiometrics __declspec(deprecated)
#endif

namespace hri_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SoftBiometrics_
{
  using Type = SoftBiometrics_<ContainerAllocator>;

  explicit SoftBiometrics_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->age = 0;
      this->age_confidence = 0.0f;
      this->gender = 0;
      this->gender_confidence = 0.0f;
    }
  }

  explicit SoftBiometrics_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->age = 0;
      this->age_confidence = 0.0f;
      this->gender = 0;
      this->gender_confidence = 0.0f;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _age_type =
    uint8_t;
  _age_type age;
  using _age_confidence_type =
    float;
  _age_confidence_type age_confidence;
  using _gender_type =
    uint8_t;
  _gender_type gender;
  using _gender_confidence_type =
    float;
  _gender_confidence_type gender_confidence;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__age(
    const uint8_t & _arg)
  {
    this->age = _arg;
    return *this;
  }
  Type & set__age_confidence(
    const float & _arg)
  {
    this->age_confidence = _arg;
    return *this;
  }
  Type & set__gender(
    const uint8_t & _arg)
  {
    this->gender = _arg;
    return *this;
  }
  Type & set__gender_confidence(
    const float & _arg)
  {
    this->gender_confidence = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t UNDEFINED =
    0u;
  static constexpr uint8_t FEMALE =
    1u;
  static constexpr uint8_t MALE =
    2u;
  static constexpr uint8_t OTHER =
    3u;

  // pointer types
  using RawPtr =
    hri_msgs::msg::SoftBiometrics_<ContainerAllocator> *;
  using ConstRawPtr =
    const hri_msgs::msg::SoftBiometrics_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hri_msgs::msg::SoftBiometrics_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hri_msgs::msg::SoftBiometrics_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::SoftBiometrics_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::SoftBiometrics_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::SoftBiometrics_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::SoftBiometrics_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hri_msgs::msg::SoftBiometrics_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hri_msgs::msg::SoftBiometrics_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hri_msgs__msg__SoftBiometrics
    std::shared_ptr<hri_msgs::msg::SoftBiometrics_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hri_msgs__msg__SoftBiometrics
    std::shared_ptr<hri_msgs::msg::SoftBiometrics_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SoftBiometrics_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->age != other.age) {
      return false;
    }
    if (this->age_confidence != other.age_confidence) {
      return false;
    }
    if (this->gender != other.gender) {
      return false;
    }
    if (this->gender_confidence != other.gender_confidence) {
      return false;
    }
    return true;
  }
  bool operator!=(const SoftBiometrics_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SoftBiometrics_

// alias to use template instance with default allocator
using SoftBiometrics =
  hri_msgs::msg::SoftBiometrics_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SoftBiometrics_<ContainerAllocator>::UNDEFINED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SoftBiometrics_<ContainerAllocator>::FEMALE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SoftBiometrics_<ContainerAllocator>::MALE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SoftBiometrics_<ContainerAllocator>::OTHER;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace hri_msgs

#endif  // HRI_MSGS__MSG__DETAIL__SOFT_BIOMETRICS__STRUCT_HPP_
