// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from hri_msgs:msg/AudioFeatures.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__AUDIO_FEATURES__TRAITS_HPP_
#define HRI_MSGS__MSG__DETAIL__AUDIO_FEATURES__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "hri_msgs/msg/detail/audio_features__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace hri_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const AudioFeatures & msg,
  std::ostream & out)
{
  out << "{";
  // member: zcr
  {
    out << "zcr: ";
    rosidl_generator_traits::value_to_yaml(msg.zcr, out);
    out << ", ";
  }

  // member: rms
  {
    out << "rms: ";
    rosidl_generator_traits::value_to_yaml(msg.rms, out);
    out << ", ";
  }

  // member: pitch
  {
    out << "pitch: ";
    rosidl_generator_traits::value_to_yaml(msg.pitch, out);
    out << ", ";
  }

  // member: hnr
  {
    out << "hnr: ";
    rosidl_generator_traits::value_to_yaml(msg.hnr, out);
    out << ", ";
  }

  // member: mfcc
  {
    if (msg.mfcc.size() == 0) {
      out << "mfcc: []";
    } else {
      out << "mfcc: [";
      size_t pending_items = msg.mfcc.size();
      for (auto item : msg.mfcc) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const AudioFeatures & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: zcr
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "zcr: ";
    rosidl_generator_traits::value_to_yaml(msg.zcr, out);
    out << "\n";
  }

  // member: rms
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rms: ";
    rosidl_generator_traits::value_to_yaml(msg.rms, out);
    out << "\n";
  }

  // member: pitch
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pitch: ";
    rosidl_generator_traits::value_to_yaml(msg.pitch, out);
    out << "\n";
  }

  // member: hnr
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "hnr: ";
    rosidl_generator_traits::value_to_yaml(msg.hnr, out);
    out << "\n";
  }

  // member: mfcc
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.mfcc.size() == 0) {
      out << "mfcc: []\n";
    } else {
      out << "mfcc:\n";
      for (auto item : msg.mfcc) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const AudioFeatures & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace hri_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hri_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hri_msgs::msg::AudioFeatures & msg,
  std::ostream & out, size_t indentation = 0)
{
  hri_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hri_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const hri_msgs::msg::AudioFeatures & msg)
{
  return hri_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<hri_msgs::msg::AudioFeatures>()
{
  return "hri_msgs::msg::AudioFeatures";
}

template<>
inline const char * name<hri_msgs::msg::AudioFeatures>()
{
  return "hri_msgs/msg/AudioFeatures";
}

template<>
struct has_fixed_size<hri_msgs::msg::AudioFeatures>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<hri_msgs::msg::AudioFeatures>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<hri_msgs::msg::AudioFeatures>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // HRI_MSGS__MSG__DETAIL__AUDIO_FEATURES__TRAITS_HPP_
