// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hri_msgs:msg/EngagementLevel.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__ENGAGEMENT_LEVEL__STRUCT_HPP_
#define HRI_MSGS__MSG__DETAIL__ENGAGEMENT_LEVEL__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hri_msgs__msg__EngagementLevel __attribute__((deprecated))
#else
# define DEPRECATED__hri_msgs__msg__EngagementLevel __declspec(deprecated)
#endif

namespace hri_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct EngagementLevel_
{
  using Type = EngagementLevel_<ContainerAllocator>;

  explicit EngagementLevel_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->level = 0;
    }
  }

  explicit EngagementLevel_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->level = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _level_type =
    uint8_t;
  _level_type level;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__level(
    const uint8_t & _arg)
  {
    this->level = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t UNKNOWN =
    0u;
  static constexpr uint8_t DISENGAGED =
    1u;
  static constexpr uint8_t ENGAGING =
    2u;
  static constexpr uint8_t ENGAGED =
    3u;
  static constexpr uint8_t DISENGAGING =
    4u;

  // pointer types
  using RawPtr =
    hri_msgs::msg::EngagementLevel_<ContainerAllocator> *;
  using ConstRawPtr =
    const hri_msgs::msg::EngagementLevel_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hri_msgs::msg::EngagementLevel_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hri_msgs::msg::EngagementLevel_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::EngagementLevel_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::EngagementLevel_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::EngagementLevel_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::EngagementLevel_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hri_msgs::msg::EngagementLevel_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hri_msgs::msg::EngagementLevel_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hri_msgs__msg__EngagementLevel
    std::shared_ptr<hri_msgs::msg::EngagementLevel_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hri_msgs__msg__EngagementLevel
    std::shared_ptr<hri_msgs::msg::EngagementLevel_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const EngagementLevel_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->level != other.level) {
      return false;
    }
    return true;
  }
  bool operator!=(const EngagementLevel_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct EngagementLevel_

// alias to use template instance with default allocator
using EngagementLevel =
  hri_msgs::msg::EngagementLevel_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t EngagementLevel_<ContainerAllocator>::UNKNOWN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t EngagementLevel_<ContainerAllocator>::DISENGAGED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t EngagementLevel_<ContainerAllocator>::ENGAGING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t EngagementLevel_<ContainerAllocator>::ENGAGED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t EngagementLevel_<ContainerAllocator>::DISENGAGING;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace hri_msgs

#endif  // HRI_MSGS__MSG__DETAIL__ENGAGEMENT_LEVEL__STRUCT_HPP_
