// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from hri_msgs:msg/FacialActionUnits.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__FACIAL_ACTION_UNITS__STRUCT_H_
#define HRI_MSGS__MSG__DETAIL__FACIAL_ACTION_UNITS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'NEUTRAL_FACE'.
/**
  * AU codes
  * List taken from https://en.wikipedia.org/wiki/Facial_Action_Coding_System
  * Main codes
  * Neutral face
 */
enum
{
  hri_msgs__msg__FacialActionUnits__NEUTRAL_FACE = 0
};

/// Constant 'INNER_BROW_RAISER'.
/**
  * Inner brow raiser
 */
enum
{
  hri_msgs__msg__FacialActionUnits__INNER_BROW_RAISER = 1
};

/// Constant 'OUTER_BROW_RAISER'.
/**
  * Outer brow raiser
 */
enum
{
  hri_msgs__msg__FacialActionUnits__OUTER_BROW_RAISER = 2
};

/// Constant 'BROW_LOWERER'.
/**
  * Brow lowerer
 */
enum
{
  hri_msgs__msg__FacialActionUnits__BROW_LOWERER = 4
};

/// Constant 'UPPER_LID_RAISER'.
/**
  * Upper lid raiser
 */
enum
{
  hri_msgs__msg__FacialActionUnits__UPPER_LID_RAISER = 5
};

/// Constant 'CHEEK_RAISER'.
/**
  * Cheek raiser
 */
enum
{
  hri_msgs__msg__FacialActionUnits__CHEEK_RAISER = 6
};

/// Constant 'LID_TIGHTENER'.
/**
  * Lid tightener
 */
enum
{
  hri_msgs__msg__FacialActionUnits__LID_TIGHTENER = 7
};

/// Constant 'LIPS_TOWARD_EACH_OTHER'.
/**
  * Lips toward each other
 */
enum
{
  hri_msgs__msg__FacialActionUnits__LIPS_TOWARD_EACH_OTHER = 8
};

/// Constant 'NOSE_WRINKLER'.
/**
  * Nose wrinkler
 */
enum
{
  hri_msgs__msg__FacialActionUnits__NOSE_WRINKLER = 9
};

/// Constant 'UPPER_LIP_RAISER'.
/**
  * Upper lip raiser
 */
enum
{
  hri_msgs__msg__FacialActionUnits__UPPER_LIP_RAISER = 10
};

/// Constant 'NASOLABIAL_DEEPENER'.
/**
  * Nasolabial deepener
 */
enum
{
  hri_msgs__msg__FacialActionUnits__NASOLABIAL_DEEPENER = 11
};

/// Constant 'LIP_CORNER_PULLER'.
/**
  * Lip corner puller
 */
enum
{
  hri_msgs__msg__FacialActionUnits__LIP_CORNER_PULLER = 12
};

/// Constant 'SHARP_LIP_PULLER'.
/**
  * Sharp lip puller
 */
enum
{
  hri_msgs__msg__FacialActionUnits__SHARP_LIP_PULLER = 13
};

/// Constant 'DIMPLER'.
/**
  * Dimpler
 */
enum
{
  hri_msgs__msg__FacialActionUnits__DIMPLER = 14
};

/// Constant 'LIP_CORNER_DEPRESSOR'.
/**
  * Lip corner depressor
 */
enum
{
  hri_msgs__msg__FacialActionUnits__LIP_CORNER_DEPRESSOR = 15
};

/// Constant 'LOWER_LIP_DEPRESSOR'.
/**
  * Lower lip depressor
 */
enum
{
  hri_msgs__msg__FacialActionUnits__LOWER_LIP_DEPRESSOR = 16
};

/// Constant 'CHIN_RAISER'.
/**
  * Chin raiser
 */
enum
{
  hri_msgs__msg__FacialActionUnits__CHIN_RAISER = 17
};

/// Constant 'LIP_PUCKER'.
/**
  * Lip pucker
 */
enum
{
  hri_msgs__msg__FacialActionUnits__LIP_PUCKER = 18
};

/// Constant 'TONGUE_SHOW'.
/**
  * Tongue show
 */
enum
{
  hri_msgs__msg__FacialActionUnits__TONGUE_SHOW = 19
};

/// Constant 'LIP_STRETCHER'.
/**
  * Lip stretcher
 */
enum
{
  hri_msgs__msg__FacialActionUnits__LIP_STRETCHER = 20
};

/// Constant 'NECK_TIGHTENER'.
/**
  * Neck tightener
 */
enum
{
  hri_msgs__msg__FacialActionUnits__NECK_TIGHTENER = 21
};

/// Constant 'LIP_FUNNELER'.
/**
  * Lip funneler
 */
enum
{
  hri_msgs__msg__FacialActionUnits__LIP_FUNNELER = 22
};

/// Constant 'LIP_TIGHTENER'.
/**
  * Lip tightener
 */
enum
{
  hri_msgs__msg__FacialActionUnits__LIP_TIGHTENER = 23
};

/// Constant 'LIP_PRESSOR'.
/**
  * Lip pressor
 */
enum
{
  hri_msgs__msg__FacialActionUnits__LIP_PRESSOR = 24
};

/// Constant 'LIPS_PART'.
/**
  * Lips part
 */
enum
{
  hri_msgs__msg__FacialActionUnits__LIPS_PART = 25
};

/// Constant 'JAW_DROP'.
/**
  * Jaw drop
 */
enum
{
  hri_msgs__msg__FacialActionUnits__JAW_DROP = 26
};

/// Constant 'MOUTH_STRETCH'.
/**
  * Mouth stretch
 */
enum
{
  hri_msgs__msg__FacialActionUnits__MOUTH_STRETCH = 27
};

/// Constant 'LIP_SUCK'.
/**
  * Lip suck
 */
enum
{
  hri_msgs__msg__FacialActionUnits__LIP_SUCK = 28
};

/// Constant 'HEAD_TURN_LEFT'.
/**
  * Head movement codes
  * Head turn left
 */
enum
{
  hri_msgs__msg__FacialActionUnits__HEAD_TURN_LEFT = 51
};

/// Constant 'HEAD_TURN_RIGHT'.
/**
  * Head turn right
 */
enum
{
  hri_msgs__msg__FacialActionUnits__HEAD_TURN_RIGHT = 52
};

/// Constant 'HEAD_UP'.
/**
  * Head up
 */
enum
{
  hri_msgs__msg__FacialActionUnits__HEAD_UP = 53
};

/// Constant 'HEAD_DOWN'.
/**
  * Head down
 */
enum
{
  hri_msgs__msg__FacialActionUnits__HEAD_DOWN = 54
};

/// Constant 'HEAD_TILT_LEFT'.
/**
  * Head tilt left
 */
enum
{
  hri_msgs__msg__FacialActionUnits__HEAD_TILT_LEFT = 55
};

/// Constant 'HEAD_TILT_RIGHT'.
/**
  * Head tilt right
 */
enum
{
  hri_msgs__msg__FacialActionUnits__HEAD_TILT_RIGHT = 56
};

/// Constant 'HEAD_FORWARD'.
/**
  * Head forward
 */
enum
{
  hri_msgs__msg__FacialActionUnits__HEAD_FORWARD = 57
};

/// Constant 'HEAD_BACK'.
/**
  * Head back
 */
enum
{
  hri_msgs__msg__FacialActionUnits__HEAD_BACK = 58
};

/// Constant 'EYES_TURN_LEFT'.
/**
  * Eye movement codes
  * Eyes turn left
 */
enum
{
  hri_msgs__msg__FacialActionUnits__EYES_TURN_LEFT = 61
};

/// Constant 'EYES_TURN_RIGHT'.
/**
  * Eyes turn right
 */
enum
{
  hri_msgs__msg__FacialActionUnits__EYES_TURN_RIGHT = 62
};

/// Constant 'EYES_UP'.
/**
  * Eyes up
 */
enum
{
  hri_msgs__msg__FacialActionUnits__EYES_UP = 63
};

/// Constant 'EYES_DOWN'.
/**
  * Eyes down
 */
enum
{
  hri_msgs__msg__FacialActionUnits__EYES_DOWN = 64
};

/// Constant 'WALLEYE'.
/**
  * Walleye
 */
enum
{
  hri_msgs__msg__FacialActionUnits__WALLEYE = 65
};

/// Constant 'CROSS_EYE'.
/**
  * Cross-eye
 */
enum
{
  hri_msgs__msg__FacialActionUnits__CROSS_EYE = 66
};

/// Constant 'EYES_POSITIONED_TO_LOOK_AT_OTHER_PERSON'.
/**
  * Eyes positioned to look at other person : The 4, 5, or 7, alone or in combination, occurs while the eye position is fixed on the other person in the conversation.
 */
enum
{
  hri_msgs__msg__FacialActionUnits__EYES_POSITIONED_TO_LOOK_AT_OTHER_PERSON = 69
};

/// Constant 'BROWS_AND_FOREHEAD_NOT_VISIBLE'.
/**
  * Visibility codes
  * Brows and forehead not visible
 */
enum
{
  hri_msgs__msg__FacialActionUnits__BROWS_AND_FOREHEAD_NOT_VISIBLE = 70
};

/// Constant 'EYES_NOT_VISIBLE'.
/**
  * Eyes not visible
 */
enum
{
  hri_msgs__msg__FacialActionUnits__EYES_NOT_VISIBLE = 71
};

/// Constant 'LOWER_FACE_NOT_VISIBLE'.
/**
  * Lower face not visible
 */
enum
{
  hri_msgs__msg__FacialActionUnits__LOWER_FACE_NOT_VISIBLE = 72
};

/// Constant 'ENTIRE_FACE_NOT_VISIBLE'.
/**
  * Entire face not visible
 */
enum
{
  hri_msgs__msg__FacialActionUnits__ENTIRE_FACE_NOT_VISIBLE = 73
};

/// Constant 'UNSOCIABLE'.
/**
  * Unsociable
 */
enum
{
  hri_msgs__msg__FacialActionUnits__UNSOCIABLE = 74
};

/// Constant 'JAW_THRUST'.
/**
  * Gross behavior codes
  * Jaw thrust
 */
enum
{
  hri_msgs__msg__FacialActionUnits__JAW_THRUST = 29
};

/// Constant 'JAW_SIDEWAYS'.
/**
  * Jaw sideways
 */
enum
{
  hri_msgs__msg__FacialActionUnits__JAW_SIDEWAYS = 30
};

/// Constant 'JAW_CLENCHER'.
/**
  * Jaw clencher : masseter
 */
enum
{
  hri_msgs__msg__FacialActionUnits__JAW_CLENCHER = 31
};

/// Constant 'LIP_BITE'.
/**
  * bite
 */
enum
{
  hri_msgs__msg__FacialActionUnits__LIP_BITE = 32
};

/// Constant 'CHEEK_BLOW'.
/**
  * blow
 */
enum
{
  hri_msgs__msg__FacialActionUnits__CHEEK_BLOW = 33
};

/// Constant 'CHEEK_PUFF'.
/**
  * puff
 */
enum
{
  hri_msgs__msg__FacialActionUnits__CHEEK_PUFF = 34
};

/// Constant 'CHEEK_SUCK'.
/**
  * suck
 */
enum
{
  hri_msgs__msg__FacialActionUnits__CHEEK_SUCK = 35
};

/// Constant 'TONGUE_BULGE'.
/**
  * bulge
 */
enum
{
  hri_msgs__msg__FacialActionUnits__TONGUE_BULGE = 36
};

/// Constant 'LIP_WIPE'.
/**
  * Lip wipe
 */
enum
{
  hri_msgs__msg__FacialActionUnits__LIP_WIPE = 37
};

/// Constant 'NOSTRIL_DILATOR'.
/**
  * Nostril dilator : nasalis (pars alaris)
 */
enum
{
  hri_msgs__msg__FacialActionUnits__NOSTRIL_DILATOR = 38
};

/// Constant 'NOSTRIL_COMPRESSOR'.
/**
  * Nostril compressor : nasalis (pars transversa) and depressor septi nasi
 */
enum
{
  hri_msgs__msg__FacialActionUnits__NOSTRIL_COMPRESSOR = 39
};

/// Constant 'SNIFF'.
/**
  * Sniff
 */
enum
{
  hri_msgs__msg__FacialActionUnits__SNIFF = 40
};

/// Constant 'LID_DROOP'.
/**
  * Lid droop : Levator palpebrae superioris (relaxation)
 */
enum
{
  hri_msgs__msg__FacialActionUnits__LID_DROOP = 41
};

/// Constant 'SLIT'.
/**
  * Slit : Orbicularis oculi muscle
 */
enum
{
  hri_msgs__msg__FacialActionUnits__SLIT = 42
};

/// Constant 'EYES_CLOSED'.
/**
  * Eyes closed : Relaxation of Levator palpebrae superioris
 */
enum
{
  hri_msgs__msg__FacialActionUnits__EYES_CLOSED = 43
};

/// Constant 'SQUINT'.
/**
  * Squint : Corrugator supercilii and orbicularis oculi muscle
 */
enum
{
  hri_msgs__msg__FacialActionUnits__SQUINT = 44
};

/// Constant 'BLINK'.
/**
  * Blink : Relaxation of Levator palpebrae superioris; contraction of orbicularis oculi (pars palpebralis)
 */
enum
{
  hri_msgs__msg__FacialActionUnits__BLINK = 45
};

/// Constant 'WINK'.
/**
  * Wink : orbicularis oculi
 */
enum
{
  hri_msgs__msg__FacialActionUnits__WINK = 46
};

/// Constant 'SPEECH'.
/**
  * Speech
 */
enum
{
  hri_msgs__msg__FacialActionUnits__SPEECH = 50
};

/// Constant 'SWALLOW'.
/**
  * Swallow
 */
enum
{
  hri_msgs__msg__FacialActionUnits__SWALLOW = 80
};

/// Constant 'CHEWING'.
/**
  * Chewing
 */
enum
{
  hri_msgs__msg__FacialActionUnits__CHEWING = 81
};

/// Constant 'SHOULDER_SHRUG'.
/**
  * Shoulder shrug
 */
enum
{
  hri_msgs__msg__FacialActionUnits__SHOULDER_SHRUG = 82
};

/// Constant 'HEAD_SHAKE_BACK_AND_FORTH'.
/**
  * Head shake back and forth
 */
enum
{
  hri_msgs__msg__FacialActionUnits__HEAD_SHAKE_BACK_AND_FORTH = 84
};

/// Constant 'HEAD_NOD_UP_AND_DOWN'.
/**
  * Head nod up and down
 */
enum
{
  hri_msgs__msg__FacialActionUnits__HEAD_NOD_UP_AND_DOWN = 85
};

/// Constant 'FLASH'.
/**
  * Flash
 */
enum
{
  hri_msgs__msg__FacialActionUnits__FLASH = 91
};

/// Constant 'PARTIAL_FLASH'.
/**
  * Partial flash
 */
enum
{
  hri_msgs__msg__FacialActionUnits__PARTIAL_FLASH = 92
};

/// Constant 'SHIVER_TREMBLE'.
/**
  * Shiver/tremble
 */
enum
{
  hri_msgs__msg__FacialActionUnits__SHIVER_TREMBLE = 97
};

/// Constant 'FAST_UP_DOWN_LOOK'.
/**
  * Fast up-down look
 */
enum
{
  hri_msgs__msg__FacialActionUnits__FAST_UP_DOWN_LOOK = 98
};

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/FacialActionUnits in the package hri_msgs.
/**
  * This message the intensity of each actions unit (AU), with their confidence, for a specific face.
  *
  * It follows the naming convention of the  Facial Action Coding System (FACS) developed by Ekman.
 */
typedef struct hri_msgs__msg__FacialActionUnits
{
  std_msgs__msg__Header header;
  /// array of 99 AUs intensities, one per AU, ordered per AU codes
  float intensity[99];
  /// array of 99 AUs intensity confidences, one per AU, ordered per AU codes
  float confidence[99];
} hri_msgs__msg__FacialActionUnits;

// Struct for a sequence of hri_msgs__msg__FacialActionUnits.
typedef struct hri_msgs__msg__FacialActionUnits__Sequence
{
  hri_msgs__msg__FacialActionUnits * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_msgs__msg__FacialActionUnits__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // HRI_MSGS__MSG__DETAIL__FACIAL_ACTION_UNITS__STRUCT_H_
