// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from hri_msgs:msg/FacialLandmarks.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__FACIAL_LANDMARKS__FUNCTIONS_H_
#define HRI_MSGS__MSG__DETAIL__FACIAL_LANDMARKS__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "hri_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "hri_msgs/msg/detail/facial_landmarks__struct.h"

/// Initialize msg/FacialLandmarks message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * hri_msgs__msg__FacialLandmarks
 * )) before or use
 * hri_msgs__msg__FacialLandmarks__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_msgs
bool
hri_msgs__msg__FacialLandmarks__init(hri_msgs__msg__FacialLandmarks * msg);

/// Finalize msg/FacialLandmarks message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_msgs
void
hri_msgs__msg__FacialLandmarks__fini(hri_msgs__msg__FacialLandmarks * msg);

/// Create msg/FacialLandmarks message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * hri_msgs__msg__FacialLandmarks__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_msgs
hri_msgs__msg__FacialLandmarks *
hri_msgs__msg__FacialLandmarks__create();

/// Destroy msg/FacialLandmarks message.
/**
 * It calls
 * hri_msgs__msg__FacialLandmarks__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_msgs
void
hri_msgs__msg__FacialLandmarks__destroy(hri_msgs__msg__FacialLandmarks * msg);

/// Check for msg/FacialLandmarks message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_msgs
bool
hri_msgs__msg__FacialLandmarks__are_equal(const hri_msgs__msg__FacialLandmarks * lhs, const hri_msgs__msg__FacialLandmarks * rhs);

/// Copy a msg/FacialLandmarks message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_msgs
bool
hri_msgs__msg__FacialLandmarks__copy(
  const hri_msgs__msg__FacialLandmarks * input,
  hri_msgs__msg__FacialLandmarks * output);

/// Initialize array of msg/FacialLandmarks messages.
/**
 * It allocates the memory for the number of elements and calls
 * hri_msgs__msg__FacialLandmarks__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_msgs
bool
hri_msgs__msg__FacialLandmarks__Sequence__init(hri_msgs__msg__FacialLandmarks__Sequence * array, size_t size);

/// Finalize array of msg/FacialLandmarks messages.
/**
 * It calls
 * hri_msgs__msg__FacialLandmarks__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_msgs
void
hri_msgs__msg__FacialLandmarks__Sequence__fini(hri_msgs__msg__FacialLandmarks__Sequence * array);

/// Create array of msg/FacialLandmarks messages.
/**
 * It allocates the memory for the array and calls
 * hri_msgs__msg__FacialLandmarks__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_msgs
hri_msgs__msg__FacialLandmarks__Sequence *
hri_msgs__msg__FacialLandmarks__Sequence__create(size_t size);

/// Destroy array of msg/FacialLandmarks messages.
/**
 * It calls
 * hri_msgs__msg__FacialLandmarks__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_msgs
void
hri_msgs__msg__FacialLandmarks__Sequence__destroy(hri_msgs__msg__FacialLandmarks__Sequence * array);

/// Check for msg/FacialLandmarks message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_msgs
bool
hri_msgs__msg__FacialLandmarks__Sequence__are_equal(const hri_msgs__msg__FacialLandmarks__Sequence * lhs, const hri_msgs__msg__FacialLandmarks__Sequence * rhs);

/// Copy an array of msg/FacialLandmarks messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_msgs
bool
hri_msgs__msg__FacialLandmarks__Sequence__copy(
  const hri_msgs__msg__FacialLandmarks__Sequence * input,
  hri_msgs__msg__FacialLandmarks__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // HRI_MSGS__MSG__DETAIL__FACIAL_LANDMARKS__FUNCTIONS_H_
