// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from hri_msgs:msg/FacialLandmarks.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__FACIAL_LANDMARKS__STRUCT_H_
#define HRI_MSGS__MSG__DETAIL__FACIAL_LANDMARKS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'RIGHT_EAR'.
/**
  * Facial landmarks codes
  * Follows dlib and OpenPose convention
  * https://github.com/CMU-Perceptual-Computing-Lab/openpose/blob/master/doc/02_output.md#face-output-format
 */
enum
{
  hri_msgs__msg__FacialLandmarks__RIGHT_EAR = 0
};

/// Constant 'RIGHT_PROFILE_1'.
enum
{
  hri_msgs__msg__FacialLandmarks__RIGHT_PROFILE_1 = 1
};

/// Constant 'RIGHT_PROFILE_2'.
enum
{
  hri_msgs__msg__FacialLandmarks__RIGHT_PROFILE_2 = 2
};

/// Constant 'RIGHT_PROFILE_3'.
enum
{
  hri_msgs__msg__FacialLandmarks__RIGHT_PROFILE_3 = 3
};

/// Constant 'RIGHT_PROFILE_4'.
enum
{
  hri_msgs__msg__FacialLandmarks__RIGHT_PROFILE_4 = 4
};

/// Constant 'RIGHT_PROFILE_5'.
enum
{
  hri_msgs__msg__FacialLandmarks__RIGHT_PROFILE_5 = 5
};

/// Constant 'RIGHT_PROFILE_6'.
enum
{
  hri_msgs__msg__FacialLandmarks__RIGHT_PROFILE_6 = 6
};

/// Constant 'RIGHT_PROFILE_7'.
enum
{
  hri_msgs__msg__FacialLandmarks__RIGHT_PROFILE_7 = 7
};

/// Constant 'MENTON'.
enum
{
  hri_msgs__msg__FacialLandmarks__MENTON = 8
};

/// Constant 'LEFT_EAR'.
enum
{
  hri_msgs__msg__FacialLandmarks__LEFT_EAR = 16
};

/// Constant 'LEFT_PROFILE_1'.
enum
{
  hri_msgs__msg__FacialLandmarks__LEFT_PROFILE_1 = 15
};

/// Constant 'LEFT_PROFILE_2'.
enum
{
  hri_msgs__msg__FacialLandmarks__LEFT_PROFILE_2 = 14
};

/// Constant 'LEFT_PROFILE_3'.
enum
{
  hri_msgs__msg__FacialLandmarks__LEFT_PROFILE_3 = 13
};

/// Constant 'LEFT_PROFILE_4'.
enum
{
  hri_msgs__msg__FacialLandmarks__LEFT_PROFILE_4 = 12
};

/// Constant 'LEFT_PROFILE_5'.
enum
{
  hri_msgs__msg__FacialLandmarks__LEFT_PROFILE_5 = 11
};

/// Constant 'LEFT_PROFILE_6'.
enum
{
  hri_msgs__msg__FacialLandmarks__LEFT_PROFILE_6 = 10
};

/// Constant 'LEFT_PROFILE_7'.
enum
{
  hri_msgs__msg__FacialLandmarks__LEFT_PROFILE_7 = 9
};

/// Constant 'RIGHT_EYEBROW_OUTSIDE'.
enum
{
  hri_msgs__msg__FacialLandmarks__RIGHT_EYEBROW_OUTSIDE = 17
};

/// Constant 'RIGHT_EYEBROW_1'.
enum
{
  hri_msgs__msg__FacialLandmarks__RIGHT_EYEBROW_1 = 18
};

/// Constant 'RIGHT_EYEBROW_2'.
enum
{
  hri_msgs__msg__FacialLandmarks__RIGHT_EYEBROW_2 = 19
};

/// Constant 'RIGHT_EYEBROW_3'.
enum
{
  hri_msgs__msg__FacialLandmarks__RIGHT_EYEBROW_3 = 20
};

/// Constant 'RIGHT_EYEBROW_INSIDE'.
enum
{
  hri_msgs__msg__FacialLandmarks__RIGHT_EYEBROW_INSIDE = 21
};

/// Constant 'RIGHT_EYE_OUTSIDE'.
enum
{
  hri_msgs__msg__FacialLandmarks__RIGHT_EYE_OUTSIDE = 36
};

/// Constant 'RIGHT_EYE_TOP_1'.
enum
{
  hri_msgs__msg__FacialLandmarks__RIGHT_EYE_TOP_1 = 37
};

/// Constant 'RIGHT_EYE_TOP_2'.
enum
{
  hri_msgs__msg__FacialLandmarks__RIGHT_EYE_TOP_2 = 38
};

/// Constant 'RIGHT_EYE_INSIDE'.
enum
{
  hri_msgs__msg__FacialLandmarks__RIGHT_EYE_INSIDE = 39
};

/// Constant 'RIGHT_EYE_BOTTOM_1'.
enum
{
  hri_msgs__msg__FacialLandmarks__RIGHT_EYE_BOTTOM_1 = 41
};

/// Constant 'RIGHT_EYE_BOTTOM_2'.
enum
{
  hri_msgs__msg__FacialLandmarks__RIGHT_EYE_BOTTOM_2 = 40
};

/// Constant 'RIGHT_PUPIL'.
enum
{
  hri_msgs__msg__FacialLandmarks__RIGHT_PUPIL = 68
};

/// Constant 'LEFT_EYEBROW_OUTSIDE'.
enum
{
  hri_msgs__msg__FacialLandmarks__LEFT_EYEBROW_OUTSIDE = 26
};

/// Constant 'LEFT_EYEBROW_1'.
enum
{
  hri_msgs__msg__FacialLandmarks__LEFT_EYEBROW_1 = 25
};

/// Constant 'LEFT_EYEBROW_2'.
enum
{
  hri_msgs__msg__FacialLandmarks__LEFT_EYEBROW_2 = 24
};

/// Constant 'LEFT_EYEBROW_3'.
enum
{
  hri_msgs__msg__FacialLandmarks__LEFT_EYEBROW_3 = 23
};

/// Constant 'LEFT_EYEBROW_INSIDE'.
enum
{
  hri_msgs__msg__FacialLandmarks__LEFT_EYEBROW_INSIDE = 22
};

/// Constant 'LEFT_EYE_OUTSIDE'.
enum
{
  hri_msgs__msg__FacialLandmarks__LEFT_EYE_OUTSIDE = 45
};

/// Constant 'LEFT_EYE_TOP_1'.
enum
{
  hri_msgs__msg__FacialLandmarks__LEFT_EYE_TOP_1 = 44
};

/// Constant 'LEFT_EYE_TOP_2'.
enum
{
  hri_msgs__msg__FacialLandmarks__LEFT_EYE_TOP_2 = 43
};

/// Constant 'LEFT_EYE_INSIDE'.
enum
{
  hri_msgs__msg__FacialLandmarks__LEFT_EYE_INSIDE = 42
};

/// Constant 'LEFT_EYE_BOTTOM_1'.
enum
{
  hri_msgs__msg__FacialLandmarks__LEFT_EYE_BOTTOM_1 = 46
};

/// Constant 'LEFT_EYE_BOTTOM_2'.
enum
{
  hri_msgs__msg__FacialLandmarks__LEFT_EYE_BOTTOM_2 = 47
};

/// Constant 'LEFT_PUPIL'.
enum
{
  hri_msgs__msg__FacialLandmarks__LEFT_PUPIL = 69
};

/// Constant 'SELLION'.
enum
{
  hri_msgs__msg__FacialLandmarks__SELLION = 27
};

/// Constant 'NOSE_1'.
enum
{
  hri_msgs__msg__FacialLandmarks__NOSE_1 = 28
};

/// Constant 'NOSE_2'.
enum
{
  hri_msgs__msg__FacialLandmarks__NOSE_2 = 29
};

/// Constant 'NOSE'.
enum
{
  hri_msgs__msg__FacialLandmarks__NOSE = 30
};

/// Constant 'NOSTRIL_1'.
enum
{
  hri_msgs__msg__FacialLandmarks__NOSTRIL_1 = 31
};

/// Constant 'NOSTRIL_2'.
enum
{
  hri_msgs__msg__FacialLandmarks__NOSTRIL_2 = 32
};

/// Constant 'NOSTRIL_3'.
enum
{
  hri_msgs__msg__FacialLandmarks__NOSTRIL_3 = 33
};

/// Constant 'NOSTRIL_4'.
enum
{
  hri_msgs__msg__FacialLandmarks__NOSTRIL_4 = 34
};

/// Constant 'NOSTRIL_5'.
enum
{
  hri_msgs__msg__FacialLandmarks__NOSTRIL_5 = 35
};

/// Constant 'MOUTH_OUTER_RIGHT'.
enum
{
  hri_msgs__msg__FacialLandmarks__MOUTH_OUTER_RIGHT = 48
};

/// Constant 'MOUTH_OUTER_TOP_1'.
enum
{
  hri_msgs__msg__FacialLandmarks__MOUTH_OUTER_TOP_1 = 49
};

/// Constant 'MOUTH_OUTER_TOP_2'.
enum
{
  hri_msgs__msg__FacialLandmarks__MOUTH_OUTER_TOP_2 = 50
};

/// Constant 'MOUTH_OUTER_TOP_3'.
enum
{
  hri_msgs__msg__FacialLandmarks__MOUTH_OUTER_TOP_3 = 51
};

/// Constant 'MOUTH_OUTER_TOP_4'.
enum
{
  hri_msgs__msg__FacialLandmarks__MOUTH_OUTER_TOP_4 = 52
};

/// Constant 'MOUTH_OUTER_TOP_5'.
enum
{
  hri_msgs__msg__FacialLandmarks__MOUTH_OUTER_TOP_5 = 53
};

/// Constant 'MOUTH_OUTER_LEFT'.
enum
{
  hri_msgs__msg__FacialLandmarks__MOUTH_OUTER_LEFT = 54
};

/// Constant 'MOUTH_OUTER_BOTTOM_1'.
enum
{
  hri_msgs__msg__FacialLandmarks__MOUTH_OUTER_BOTTOM_1 = 59
};

/// Constant 'MOUTH_OUTER_BOTTOM_2'.
enum
{
  hri_msgs__msg__FacialLandmarks__MOUTH_OUTER_BOTTOM_2 = 58
};

/// Constant 'MOUTH_OUTER_BOTTOM_3'.
enum
{
  hri_msgs__msg__FacialLandmarks__MOUTH_OUTER_BOTTOM_3 = 57
};

/// Constant 'MOUTH_OUTER_BOTTOM_4'.
enum
{
  hri_msgs__msg__FacialLandmarks__MOUTH_OUTER_BOTTOM_4 = 56
};

/// Constant 'MOUTH_OUTER_BOTTOM_5'.
enum
{
  hri_msgs__msg__FacialLandmarks__MOUTH_OUTER_BOTTOM_5 = 55
};

/// Constant 'MOUTH_INNER_RIGHT'.
enum
{
  hri_msgs__msg__FacialLandmarks__MOUTH_INNER_RIGHT = 60
};

/// Constant 'MOUTH_INNER_TOP_1'.
enum
{
  hri_msgs__msg__FacialLandmarks__MOUTH_INNER_TOP_1 = 61
};

/// Constant 'MOUTH_INNER_TOP_2'.
enum
{
  hri_msgs__msg__FacialLandmarks__MOUTH_INNER_TOP_2 = 62
};

/// Constant 'MOUTH_INNER_TOP_3'.
enum
{
  hri_msgs__msg__FacialLandmarks__MOUTH_INNER_TOP_3 = 63
};

/// Constant 'MOUTH_INNER_LEFT'.
enum
{
  hri_msgs__msg__FacialLandmarks__MOUTH_INNER_LEFT = 64
};

/// Constant 'MOUTH_INNER_BOTTOM_1'.
enum
{
  hri_msgs__msg__FacialLandmarks__MOUTH_INNER_BOTTOM_1 = 67
};

/// Constant 'MOUTH_INNER_BOTTOM_2'.
enum
{
  hri_msgs__msg__FacialLandmarks__MOUTH_INNER_BOTTOM_2 = 66
};

/// Constant 'MOUTH_INNER_BOTTOM_3'.
enum
{
  hri_msgs__msg__FacialLandmarks__MOUTH_INNER_BOTTOM_3 = 65
};

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'landmarks'
#include "hri_msgs/msg/detail/normalized_point_of_interest2_d__struct.h"

/// Struct defined in msg/FacialLandmarks in the package hri_msgs.
/**
  * This message contains a list of facial features detected on a face
  * (0, 0) is at top-left corner of image
  * Features' coordinates are expressed in normalised pixel coordinates 
  * (in the range [0., 1.]), from the top-left corner.
 */
typedef struct hri_msgs__msg__FacialLandmarks
{
  std_msgs__msg__Header header;
  /// array of 70 landmark normalized coordinates, one per landmark, ordered per landmarks codes
  hri_msgs__msg__NormalizedPointOfInterest2D landmarks[70];
  /// image height in pixels, that is, number of rows
  uint32_t height;
  /// image width in pixels, that is, number of columns
  uint32_t width;
} hri_msgs__msg__FacialLandmarks;

// Struct for a sequence of hri_msgs__msg__FacialLandmarks.
typedef struct hri_msgs__msg__FacialLandmarks__Sequence
{
  hri_msgs__msg__FacialLandmarks * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_msgs__msg__FacialLandmarks__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // HRI_MSGS__MSG__DETAIL__FACIAL_LANDMARKS__STRUCT_H_
