// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from hri_msgs:msg/Gaze.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__GAZE__STRUCT_H_
#define HRI_MSGS__MSG__DETAIL__GAZE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'sender'
// Member 'receiver'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/Gaze in the package hri_msgs.
/**
  * Represents the gaze direction from a particular person (sender ID) to the
  * person that is being gazed to (receiver ID).
  *
  * If the sender or receiver IDs are empty, it means that the gaze respectively
  * originates or is targeted to the robot itself.
 */
typedef struct hri_msgs__msg__Gaze
{
  std_msgs__msg__Header header;
  rosidl_runtime_c__String sender;
  rosidl_runtime_c__String receiver;
} hri_msgs__msg__Gaze;

// Struct for a sequence of hri_msgs__msg__Gaze.
typedef struct hri_msgs__msg__Gaze__Sequence
{
  hri_msgs__msg__Gaze * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_msgs__msg__Gaze__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // HRI_MSGS__MSG__DETAIL__GAZE__STRUCT_H_
