// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from hri_msgs:msg/Gesture.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__GESTURE__STRUCT_H_
#define HRI_MSGS__MSG__DETAIL__GESTURE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'HANDS_ON_FACE'.
/**
  * Additional gestures might be added in the future, please open
  * issues/pull requests to suggest new ones.
 */
enum
{
  hri_msgs__msg__Gesture__HANDS_ON_FACE = 1
};

/// Constant 'ARMS_CROSSED'.
enum
{
  hri_msgs__msg__Gesture__ARMS_CROSSED = 2
};

/// Constant 'LEFT_HAND_RAISED'.
enum
{
  hri_msgs__msg__Gesture__LEFT_HAND_RAISED = 3
};

/// Constant 'RIGHT_HAND_RAISED'.
enum
{
  hri_msgs__msg__Gesture__RIGHT_HAND_RAISED = 4
};

/// Constant 'BOTH_HANDS_RAISED'.
enum
{
  hri_msgs__msg__Gesture__BOTH_HANDS_RAISED = 5
};

/// Constant 'WAVING'.
/**
  * eg, greeting someone with the hand
 */
enum
{
  hri_msgs__msg__Gesture__WAVING = 6
};

/// Constant 'OTHER'.
enum
{
  hri_msgs__msg__Gesture__OTHER = 0
};

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/Gesture in the package hri_msgs.
/**
  * Describes body language/attitude/gesture detected from a body.
 */
typedef struct hri_msgs__msg__Gesture
{
  std_msgs__msg__Header header;
  /// one of the above constants
  uint8_t gesture;
} hri_msgs__msg__Gesture;

// Struct for a sequence of hri_msgs__msg__Gesture.
typedef struct hri_msgs__msg__Gesture__Sequence
{
  hri_msgs__msg__Gesture * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_msgs__msg__Gesture__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // HRI_MSGS__MSG__DETAIL__GESTURE__STRUCT_H_
