// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hri_msgs:msg/Gesture.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__GESTURE__STRUCT_HPP_
#define HRI_MSGS__MSG__DETAIL__GESTURE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hri_msgs__msg__Gesture __attribute__((deprecated))
#else
# define DEPRECATED__hri_msgs__msg__Gesture __declspec(deprecated)
#endif

namespace hri_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Gesture_
{
  using Type = Gesture_<ContainerAllocator>;

  explicit Gesture_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->gesture = 0;
    }
  }

  explicit Gesture_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->gesture = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _gesture_type =
    uint8_t;
  _gesture_type gesture;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__gesture(
    const uint8_t & _arg)
  {
    this->gesture = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t HANDS_ON_FACE =
    1u;
  static constexpr uint8_t ARMS_CROSSED =
    2u;
  static constexpr uint8_t LEFT_HAND_RAISED =
    3u;
  static constexpr uint8_t RIGHT_HAND_RAISED =
    4u;
  static constexpr uint8_t BOTH_HANDS_RAISED =
    5u;
  static constexpr uint8_t WAVING =
    6u;
  static constexpr uint8_t OTHER =
    0u;

  // pointer types
  using RawPtr =
    hri_msgs::msg::Gesture_<ContainerAllocator> *;
  using ConstRawPtr =
    const hri_msgs::msg::Gesture_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hri_msgs::msg::Gesture_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hri_msgs::msg::Gesture_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::Gesture_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::Gesture_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::Gesture_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::Gesture_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hri_msgs::msg::Gesture_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hri_msgs::msg::Gesture_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hri_msgs__msg__Gesture
    std::shared_ptr<hri_msgs::msg::Gesture_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hri_msgs__msg__Gesture
    std::shared_ptr<hri_msgs::msg::Gesture_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Gesture_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->gesture != other.gesture) {
      return false;
    }
    return true;
  }
  bool operator!=(const Gesture_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Gesture_

// alias to use template instance with default allocator
using Gesture =
  hri_msgs::msg::Gesture_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Gesture_<ContainerAllocator>::HANDS_ON_FACE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Gesture_<ContainerAllocator>::ARMS_CROSSED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Gesture_<ContainerAllocator>::LEFT_HAND_RAISED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Gesture_<ContainerAllocator>::RIGHT_HAND_RAISED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Gesture_<ContainerAllocator>::BOTH_HANDS_RAISED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Gesture_<ContainerAllocator>::WAVING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Gesture_<ContainerAllocator>::OTHER;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace hri_msgs

#endif  // HRI_MSGS__MSG__DETAIL__GESTURE__STRUCT_HPP_
