// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from hri_msgs:msg/IdsList.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__IDS_LIST__STRUCT_H_
#define HRI_MSGS__MSG__DETAIL__IDS_LIST__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'ids'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/IdsList in the package hri_msgs.
/**
  * This message encodes a list of ROS4HRI IDs (eg face ids, body ids, person
  * ids...).
  * It is for instance published on /humans/faces/tracked to access the list of
  * currently detected faces.
 */
typedef struct hri_msgs__msg__IdsList
{
  std_msgs__msg__Header header;
  rosidl_runtime_c__String__Sequence ids;
} hri_msgs__msg__IdsList;

// Struct for a sequence of hri_msgs__msg__IdsList.
typedef struct hri_msgs__msg__IdsList__Sequence
{
  hri_msgs__msg__IdsList * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_msgs__msg__IdsList__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // HRI_MSGS__MSG__DETAIL__IDS_LIST__STRUCT_H_
