// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from hri_msgs:msg/IdsMatch.idl
// generated code does not contain a copyright notice
#include "hri_msgs/msg/detail/ids_match__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `id1`
// Member `id2`
#include "rosidl_runtime_c/string_functions.h"

bool
hri_msgs__msg__IdsMatch__init(hri_msgs__msg__IdsMatch * msg)
{
  if (!msg) {
    return false;
  }
  // id1
  if (!rosidl_runtime_c__String__init(&msg->id1)) {
    hri_msgs__msg__IdsMatch__fini(msg);
    return false;
  }
  // id1_type
  // id2
  if (!rosidl_runtime_c__String__init(&msg->id2)) {
    hri_msgs__msg__IdsMatch__fini(msg);
    return false;
  }
  // id2_type
  // confidence
  return true;
}

void
hri_msgs__msg__IdsMatch__fini(hri_msgs__msg__IdsMatch * msg)
{
  if (!msg) {
    return;
  }
  // id1
  rosidl_runtime_c__String__fini(&msg->id1);
  // id1_type
  // id2
  rosidl_runtime_c__String__fini(&msg->id2);
  // id2_type
  // confidence
}

bool
hri_msgs__msg__IdsMatch__are_equal(const hri_msgs__msg__IdsMatch * lhs, const hri_msgs__msg__IdsMatch * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // id1
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->id1), &(rhs->id1)))
  {
    return false;
  }
  // id1_type
  if (lhs->id1_type != rhs->id1_type) {
    return false;
  }
  // id2
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->id2), &(rhs->id2)))
  {
    return false;
  }
  // id2_type
  if (lhs->id2_type != rhs->id2_type) {
    return false;
  }
  // confidence
  if (lhs->confidence != rhs->confidence) {
    return false;
  }
  return true;
}

bool
hri_msgs__msg__IdsMatch__copy(
  const hri_msgs__msg__IdsMatch * input,
  hri_msgs__msg__IdsMatch * output)
{
  if (!input || !output) {
    return false;
  }
  // id1
  if (!rosidl_runtime_c__String__copy(
      &(input->id1), &(output->id1)))
  {
    return false;
  }
  // id1_type
  output->id1_type = input->id1_type;
  // id2
  if (!rosidl_runtime_c__String__copy(
      &(input->id2), &(output->id2)))
  {
    return false;
  }
  // id2_type
  output->id2_type = input->id2_type;
  // confidence
  output->confidence = input->confidence;
  return true;
}

hri_msgs__msg__IdsMatch *
hri_msgs__msg__IdsMatch__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_msgs__msg__IdsMatch * msg = (hri_msgs__msg__IdsMatch *)allocator.allocate(sizeof(hri_msgs__msg__IdsMatch), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(hri_msgs__msg__IdsMatch));
  bool success = hri_msgs__msg__IdsMatch__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
hri_msgs__msg__IdsMatch__destroy(hri_msgs__msg__IdsMatch * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    hri_msgs__msg__IdsMatch__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
hri_msgs__msg__IdsMatch__Sequence__init(hri_msgs__msg__IdsMatch__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_msgs__msg__IdsMatch * data = NULL;

  if (size) {
    data = (hri_msgs__msg__IdsMatch *)allocator.zero_allocate(size, sizeof(hri_msgs__msg__IdsMatch), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = hri_msgs__msg__IdsMatch__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        hri_msgs__msg__IdsMatch__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
hri_msgs__msg__IdsMatch__Sequence__fini(hri_msgs__msg__IdsMatch__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      hri_msgs__msg__IdsMatch__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

hri_msgs__msg__IdsMatch__Sequence *
hri_msgs__msg__IdsMatch__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_msgs__msg__IdsMatch__Sequence * array = (hri_msgs__msg__IdsMatch__Sequence *)allocator.allocate(sizeof(hri_msgs__msg__IdsMatch__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = hri_msgs__msg__IdsMatch__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
hri_msgs__msg__IdsMatch__Sequence__destroy(hri_msgs__msg__IdsMatch__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    hri_msgs__msg__IdsMatch__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
hri_msgs__msg__IdsMatch__Sequence__are_equal(const hri_msgs__msg__IdsMatch__Sequence * lhs, const hri_msgs__msg__IdsMatch__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!hri_msgs__msg__IdsMatch__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
hri_msgs__msg__IdsMatch__Sequence__copy(
  const hri_msgs__msg__IdsMatch__Sequence * input,
  hri_msgs__msg__IdsMatch__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(hri_msgs__msg__IdsMatch);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    hri_msgs__msg__IdsMatch * data =
      (hri_msgs__msg__IdsMatch *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!hri_msgs__msg__IdsMatch__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          hri_msgs__msg__IdsMatch__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!hri_msgs__msg__IdsMatch__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
