// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hri_msgs:msg/IdsMatch.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__IDS_MATCH__STRUCT_HPP_
#define HRI_MSGS__MSG__DETAIL__IDS_MATCH__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__hri_msgs__msg__IdsMatch __attribute__((deprecated))
#else
# define DEPRECATED__hri_msgs__msg__IdsMatch __declspec(deprecated)
#endif

namespace hri_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct IdsMatch_
{
  using Type = IdsMatch_<ContainerAllocator>;

  explicit IdsMatch_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id1 = "";
      this->id1_type = 0;
      this->id2 = "";
      this->id2_type = 0;
      this->confidence = 0.0f;
    }
  }

  explicit IdsMatch_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : id1(_alloc),
    id2(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id1 = "";
      this->id1_type = 0;
      this->id2 = "";
      this->id2_type = 0;
      this->confidence = 0.0f;
    }
  }

  // field types and members
  using _id1_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _id1_type id1;
  using _id1_type_type =
    int8_t;
  _id1_type_type id1_type;
  using _id2_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _id2_type id2;
  using _id2_type_type =
    int8_t;
  _id2_type_type id2_type;
  using _confidence_type =
    float;
  _confidence_type confidence;

  // setters for named parameter idiom
  Type & set__id1(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->id1 = _arg;
    return *this;
  }
  Type & set__id1_type(
    const int8_t & _arg)
  {
    this->id1_type = _arg;
    return *this;
  }
  Type & set__id2(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->id2 = _arg;
    return *this;
  }
  Type & set__id2_type(
    const int8_t & _arg)
  {
    this->id2_type = _arg;
    return *this;
  }
  Type & set__confidence(
    const float & _arg)
  {
    this->confidence = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int8_t UNSET =
    0;
  static constexpr int8_t PERSON =
    1;
  static constexpr int8_t FACE =
    2;
  static constexpr int8_t BODY =
    3;
  static constexpr int8_t VOICE =
    4;

  // pointer types
  using RawPtr =
    hri_msgs::msg::IdsMatch_<ContainerAllocator> *;
  using ConstRawPtr =
    const hri_msgs::msg::IdsMatch_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hri_msgs::msg::IdsMatch_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hri_msgs::msg::IdsMatch_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::IdsMatch_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::IdsMatch_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::IdsMatch_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::IdsMatch_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hri_msgs::msg::IdsMatch_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hri_msgs::msg::IdsMatch_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hri_msgs__msg__IdsMatch
    std::shared_ptr<hri_msgs::msg::IdsMatch_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hri_msgs__msg__IdsMatch
    std::shared_ptr<hri_msgs::msg::IdsMatch_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const IdsMatch_ & other) const
  {
    if (this->id1 != other.id1) {
      return false;
    }
    if (this->id1_type != other.id1_type) {
      return false;
    }
    if (this->id2 != other.id2) {
      return false;
    }
    if (this->id2_type != other.id2_type) {
      return false;
    }
    if (this->confidence != other.confidence) {
      return false;
    }
    return true;
  }
  bool operator!=(const IdsMatch_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct IdsMatch_

// alias to use template instance with default allocator
using IdsMatch =
  hri_msgs::msg::IdsMatch_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int8_t IdsMatch_<ContainerAllocator>::UNSET;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int8_t IdsMatch_<ContainerAllocator>::PERSON;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int8_t IdsMatch_<ContainerAllocator>::FACE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int8_t IdsMatch_<ContainerAllocator>::BODY;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int8_t IdsMatch_<ContainerAllocator>::VOICE;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace hri_msgs

#endif  // HRI_MSGS__MSG__DETAIL__IDS_MATCH__STRUCT_HPP_
