// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from hri_msgs:msg/NormalizedPointOfInterest2DStamped.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__NORMALIZED_POINT_OF_INTEREST2_D_STAMPED__STRUCT_H_
#define HRI_MSGS__MSG__DETAIL__NORMALIZED_POINT_OF_INTEREST2_D_STAMPED__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/NormalizedPointOfInterest2DStamped in the package hri_msgs.
/**
  * This contains the position of a point of interest (typically in an image)
  * the coordinates are always normalized and must belong to [0.,1.].
  * c is a confidence level (between 0. and 1.) associated to that POI
 */
typedef struct hri_msgs__msg__NormalizedPointOfInterest2DStamped
{
  /// Header timestamp should be acquisition time of the original image
  std_msgs__msg__Header header;
  float x;
  float y;
  float c;
} hri_msgs__msg__NormalizedPointOfInterest2DStamped;

// Struct for a sequence of hri_msgs__msg__NormalizedPointOfInterest2DStamped.
typedef struct hri_msgs__msg__NormalizedPointOfInterest2DStamped__Sequence
{
  hri_msgs__msg__NormalizedPointOfInterest2DStamped * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_msgs__msg__NormalizedPointOfInterest2DStamped__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // HRI_MSGS__MSG__DETAIL__NORMALIZED_POINT_OF_INTEREST2_D_STAMPED__STRUCT_H_
