// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hri_msgs:msg/NormalizedPointOfInterest2DStamped.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__NORMALIZED_POINT_OF_INTEREST2_D_STAMPED__STRUCT_HPP_
#define HRI_MSGS__MSG__DETAIL__NORMALIZED_POINT_OF_INTEREST2_D_STAMPED__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hri_msgs__msg__NormalizedPointOfInterest2DStamped __attribute__((deprecated))
#else
# define DEPRECATED__hri_msgs__msg__NormalizedPointOfInterest2DStamped __declspec(deprecated)
#endif

namespace hri_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct NormalizedPointOfInterest2DStamped_
{
  using Type = NormalizedPointOfInterest2DStamped_<ContainerAllocator>;

  explicit NormalizedPointOfInterest2DStamped_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->x = 0.0f;
      this->y = 0.0f;
      this->c = 0.0f;
    }
  }

  explicit NormalizedPointOfInterest2DStamped_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->x = 0.0f;
      this->y = 0.0f;
      this->c = 0.0f;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _x_type =
    float;
  _x_type x;
  using _y_type =
    float;
  _y_type y;
  using _c_type =
    float;
  _c_type c;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__x(
    const float & _arg)
  {
    this->x = _arg;
    return *this;
  }
  Type & set__y(
    const float & _arg)
  {
    this->y = _arg;
    return *this;
  }
  Type & set__c(
    const float & _arg)
  {
    this->c = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hri_msgs::msg::NormalizedPointOfInterest2DStamped_<ContainerAllocator> *;
  using ConstRawPtr =
    const hri_msgs::msg::NormalizedPointOfInterest2DStamped_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hri_msgs::msg::NormalizedPointOfInterest2DStamped_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hri_msgs::msg::NormalizedPointOfInterest2DStamped_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::NormalizedPointOfInterest2DStamped_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::NormalizedPointOfInterest2DStamped_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::NormalizedPointOfInterest2DStamped_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::NormalizedPointOfInterest2DStamped_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hri_msgs::msg::NormalizedPointOfInterest2DStamped_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hri_msgs::msg::NormalizedPointOfInterest2DStamped_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hri_msgs__msg__NormalizedPointOfInterest2DStamped
    std::shared_ptr<hri_msgs::msg::NormalizedPointOfInterest2DStamped_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hri_msgs__msg__NormalizedPointOfInterest2DStamped
    std::shared_ptr<hri_msgs::msg::NormalizedPointOfInterest2DStamped_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const NormalizedPointOfInterest2DStamped_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->x != other.x) {
      return false;
    }
    if (this->y != other.y) {
      return false;
    }
    if (this->c != other.c) {
      return false;
    }
    return true;
  }
  bool operator!=(const NormalizedPointOfInterest2DStamped_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct NormalizedPointOfInterest2DStamped_

// alias to use template instance with default allocator
using NormalizedPointOfInterest2DStamped =
  hri_msgs::msg::NormalizedPointOfInterest2DStamped_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace hri_msgs

#endif  // HRI_MSGS__MSG__DETAIL__NORMALIZED_POINT_OF_INTEREST2_D_STAMPED__STRUCT_HPP_
