// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from hri_msgs:msg/Skeleton2D.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__SKELETON2_D__TRAITS_HPP_
#define HRI_MSGS__MSG__DETAIL__SKELETON2_D__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "hri_msgs/msg/detail/skeleton2_d__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'skeleton'
#include "hri_msgs/msg/detail/normalized_point_of_interest2_d__traits.hpp"

namespace hri_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Skeleton2D & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: skeleton
  {
    if (msg.skeleton.size() == 0) {
      out << "skeleton: []";
    } else {
      out << "skeleton: [";
      size_t pending_items = msg.skeleton.size();
      for (auto item : msg.skeleton) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Skeleton2D & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: skeleton
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.skeleton.size() == 0) {
      out << "skeleton: []\n";
    } else {
      out << "skeleton:\n";
      for (auto item : msg.skeleton) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Skeleton2D & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace hri_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hri_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hri_msgs::msg::Skeleton2D & msg,
  std::ostream & out, size_t indentation = 0)
{
  hri_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hri_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const hri_msgs::msg::Skeleton2D & msg)
{
  return hri_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<hri_msgs::msg::Skeleton2D>()
{
  return "hri_msgs::msg::Skeleton2D";
}

template<>
inline const char * name<hri_msgs::msg::Skeleton2D>()
{
  return "hri_msgs/msg/Skeleton2D";
}

template<>
struct has_fixed_size<hri_msgs::msg::Skeleton2D>
  : std::integral_constant<bool, has_fixed_size<hri_msgs::msg::NormalizedPointOfInterest2D>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<hri_msgs::msg::Skeleton2D>
  : std::integral_constant<bool, has_bounded_size<hri_msgs::msg::NormalizedPointOfInterest2D>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<hri_msgs::msg::Skeleton2D>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // HRI_MSGS__MSG__DETAIL__SKELETON2_D__TRAITS_HPP_
